    //
    //  Header files.
    //
    //  The header files provide access to functionality in the
    //  Rockall-DB library.
    //
#include "TextFile.hpp"

    //
    //  Text File (Constructor).
    //
    //  The text file class does not use Rockall-DB and exists
    //  purely to read the book into the database from a standard
    //  text file.
    //
TEXT_FILE::TEXT_FILE( void )
    { Active = False; }

    //
    //  Open.
    //
    //  Open a text file and compute its size.
    //
BOOLEAN TEXT_FILE::Open( char *FileName,FILE_SIZE *FileSize )
    {
    if ( ! Active )
        {
        if ( (File = fopen( FileName,"rb" )) != NULL )
            {
            if
                    (
                    (fseek( File,0L,SEEK_END ) == 0)
                        &&
                    (((*FileSize) = ftell( File )) != -1)
                        &&
                    (fseek( File,0L,SEEK_SET ) == 0)
                    )
                { return (Active = True); }

            fclose( File );
            }
        }

    return False;
    }

    //
    //  Read.
    //
    //  Read the entire contents of a text file.
    //
BOOLEAN TEXT_FILE::Read( char *Buffer,FILE_SIZE Size )
    {
    if ( Active )
        { return ((fread( Buffer,1,((size_t) Size),File ) == Size)); }

    return False;
    }

    //
    //  Close.
    //
    //  Close a text file.
    //
BOOLEAN TEXT_FILE::Close( void )
    {
    if ( Active )
        { return (Active = (fclose( File ) != 0)); }

    return False;
    }

    //
    //  Text File (Destructor).
    //
TEXT_FILE::~TEXT_FILE( void )
    {
    if ( Active )
        { Close(); }

    Active = False;
    }