#ifndef _TEXT_FILE_HPP_
#define _TEXT_FILE_HPP_ 1
    //
    //  Header files.
    //
    //  The header files provide access to functionality in the
    //  Rockall-DB library.
    //
#include <stdio.h>

#include "RockallTypes.hpp"

    //
    //  Text File.
    //
    //  The text file class does not use Rockall-DB and exists
    //  purely to read the book into the database from a standard
    //  text file.
    //
class TEXT_FILE
    {
        //
        //  Private data.
        //
        BOOLEAN                             Active;
        FILE                                *File;

    public:
        //
        //  Public functions.
        //
        TEXT_FILE( void );

        BOOLEAN Open( char *FileName,FILE_SIZE *FileSize );

        BOOLEAN Read( char *Buffer,FILE_SIZE Size );

        BOOLEAN Close( void );

        ~TEXT_FILE( void );

    private:
        //
        //  Disabled functionality.
        //
        TEXT_FILE( const TEXT_FILE & NoCopies );

        void operator=( const TEXT_FILE & NoCopies );
    };
#endif