#ifdef ROCKALL_DB_EXAMPLES
#define main Example_01_03
#endif

#include <stdio.h>
#include <string.h>

#include "AutomaticHeapScope.hpp"
#include "Example-01-02.hpp"
#include "RockallNew.hpp"

int main( int Count,char *Argument[] )
  {
  HEAP_TYPE Heap;

  if ( (Count == 2) && (Heap.CreateFile( Argument[1] )) )
    {
    AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
    static const int MaxRows = 5;
    static ROW Rows[ MaxRows] =
      {
      { 1,"One","Value1","Value2" },
      { 2,"Two","Value3","Value4" },
      { 3,"Three","Value5","Value6" },
      { 4,"Four","Value7","Value8" },
      { 5,"Five","Value9","Value10" }
      };

    if ( Heap.BeginTransaction() )
      {
      bool Abort = false;
      FILE_ADDRESS Address;
      ROOT *Root;

      if ( ROCKALL_NEW<ROOT>::New( & Heap,& Address,& Root ) )
        {
        int Count;

        for( Count=0;Count < MaxRows;Count ++ )
          {
          ROW *Row1 = & Rows[ Count ];
          ROW *Row2;

          if
              (
              (ROCKALL_NEW<ROW>::New( & Heap,& Address,& Row2 ))
                &&
              (Root -> Index1.NewKey( Row1 -> Key1,Address ))
                &&
              (Root -> Index2.NewKey( Row1 -> Key2,Address ))
              )
            { (*Row2) = (*Row1);  }
          else
            { Abort = true; }
          }
        }
      else
        { Abort = true; }

      Heap.EndTransaction( Abort );
      }

    Heap.CloseFile();
    }

  return 0;
  }
