#ifdef ROCKALL_DB_EXAMPLES
#define main Example_04_01
#endif

#include "AutomaticHeapScope.hpp"
#include "DatabaseHeap.hpp"
#include "Failure.hpp"
#include "Stack.hpp"

static void PushAndPop( void )
  {
  STACK<DATABASE_HEAP,NO_LOCK,int> Stack;
  static const int MaxCycles = 100;
  int Count;
  int Value;

  for
    (
    Count=0;
    (Count < MaxCycles) && (Stack.PushValue( Count ));
    Count ++
    );

  if ( Count < MaxCycles )
    { FAILURE( "Unable to push all the values" ); }

  for
    (
    /* void */;
    (Count > 0) && (Stack.PopValue( & Value ));
    Count --
    );

  if ( Count > 0 )
    { FAILURE( "Unable to pop all the values" ); }
  }

int main( int Count,char *Argument[] )
  {
  DATABASE_HEAP Heap;
  AUTOMATIC_HEAP_SCOPE<DATABASE_HEAP> Scope( & Heap );

  if ( (Count == 2) && (Heap.CreateFile( Argument[1] )) )
    {
    PushAndPop();

    Heap.CloseFile();
    }

  return 0;
  }

