#ifdef ROCKALL_DB_EXAMPLES
#define main Example_04_09
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "Example-04-08.hpp"
#include "Failure.hpp"
#include "Hash.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,MaxName> NAME;
typedef HASH<HEAP_TYPE,NO_LOCK,NAME,DETAILS*> INDEX;

static bool CreateIndex( INDEX *Index )
  {
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope;
  int Count;

  for ( Count=0;Count < MaxDetails;Count ++ )
    {
    DETAILS *Current = & Details[ Count ];
    NAME Name1 = Current -> Forename;
    NAME Name2 = Current -> Surname;

    if
        (
        (! Index -> NewKey( & Scope,Name1,Current ))
          ||
        (! Index -> NewKey( & Scope,Name2,Current ))
        )
      { FAILURE( "Unable to add key" ); }
    }

  return (Count == MaxDetails);
  }

static void FindKey( char *Name,INDEX *Index )
  {
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope;
  NAME Key = Name;
  DETAILS *Target;

  if ( Index -> FindKey( & Scope,Key,& Target ) )
    {
    printf
      (
      "The details are: '%s %s' at '%s'\n",
      Target -> Forename,
      Target -> Surname,
      Target -> Postcode
      );
    }
  }

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  INDEX Index;

  if ( CreateIndex( & Index ) )
    { FindKey( Details[2].Forename,& Index ); }

  return 0;
  }
