#ifdef ROCKALL_DB_EXAMPLES
#define main Example_04_10
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "AutomaticViewScope.hpp"
#include "Example-04-08.hpp"
#include "Failure.hpp"
#include "Hash.hpp"
#include "RockallNew.hpp"
#include "RockallTypes.hpp"

typedef DATABASE_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,MaxName> NAME;
typedef HASH<HEAP_TYPE,NO_LOCK,NAME,FILE_ADDRESS> INDEX;

static bool CreateIndex( INDEX *Index )
  {
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope;
  int Count;

  for ( Count=0;Count < MaxDetails;Count ++ )
    {
    DETAILS *Current1 = & Details[ Count ];
    NAME Name1 = Current1 -> Forename;
    NAME Name2 = Current1 -> Surname;
    FILE_ADDRESS Address;
    DETAILS *Current2;

    if
        (
        (ROCKALL_NEW<DETAILS>::New( & Scope,& Address,& Current2 ))
          &&
        (Index -> NewKey( & Scope,Name1,Address ))
          &&
        (Index -> NewKey( & Scope,Name2,Address ))
        )
      { (*Current2) = (*Current1); }
    else
      { FAILURE( "Unable to add key" ); }
    }

  return (Count == MaxDetails);
  }

static void FindKey( char *Name,INDEX *Index )
  {
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope;
  FILE_ADDRESS Address;
  NAME Key = Name;

  if ( Index -> FindKey( & Scope,Key,& Address ) )
    {
    AUTOMATIC_VIEW_SCOPE<HEAP_TYPE> ViewScope( & Scope );
    DETAILS *Target;

    if ( ViewScope.View( Address,((void**) & Target) ) )
      {
      printf
        (
        "The details are: '%s %s' at '%s'\n",
        Target -> Forename,
        Target -> Surname,
        Target -> Postcode
        );
      }
    }
  }

int main( int Count,char *Argument[] )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );

  if ( (Count==2) && (Scope.CreateFile( Argument[1] )) )
    {
    if ( Scope.BeginTransaction() )
      {
      INDEX Index;

      if ( CreateIndex( & Index ) )
        { FindKey( Details[2].Forename,& Index ); }

      Scope.EndTransaction();
      }

    Scope.CloseFile();
    }

  return 0;
  }
