#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_05
#endif

#include "AutomaticHeapScope.hpp"
#include "DatabaseHeap.hpp"
#include "RockallTypes.hpp"
#include "Stack.hpp"

typedef DATABASE_HEAP HEAP_TYPE;

int main( int Count,char *Argument[] )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  int Result = 1;

  if ( Count == 2 )
    {
    BOOLEAN Active;

    if ( (Active = (Scope.CreateFile( Argument[1] ))) )
      {
      AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope2;

      if ( Scope2.BeginTransaction() )
        {
        STACK<HEAP_TYPE,NO_LOCK,int> Stack( & Scope2 );

        if ( Stack.PushValue( & Scope2,0 ) )
          { Result = 0; }
        }
      }

    if ( Active )
      { Scope.CloseFile(); }
    }

  return Result;
  }