#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_10
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "FixedString.hpp"
#include "RockallTypes.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,64> ASCII_STRING;
typedef FIXED_STRING<HEAP_TYPE,wchar_t,64> WIDE_STRING;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );

  ASCII_STRING String1;
  ASCII_STRING String2 = "Any ascii text";
  ASCII_STRING String3 = String2;

  WIDE_STRING String4;
  WIDE_STRING String5 = L"Any wchar text";
  WIDE_STRING String6 = String5;

  FILE_SIZE StringSize;
  char Value1[64];
  wchar_t Value2[64];

  String1 = String5;
  String4 = String2;

  String1 += " + add more ascii text";
  String4 += L" + add more wchar text";

  if
      (
      (String1 == "Test ascii string")
        &&
      (String1 != String2)
        &&
      (String1 > "Test ascii string")
        &&
      (String1 >= String2)
        &&
      (String1 < "Test ascii string")
        &&
      (String1 <= String2)
        &&
      (String1.Size( & StringSize ))
        &&
      (String1.Lower())
        &&
      (String1.Size( & StringSize ))
        &&
      (String1.Upper())
        &&
      (String1.Value( & Scope,64,& StringSize,Value1 ))
      )
    { printf( "We can compare ascii strings\n" ); }

  if
      (
      (String4 == L"Test wchar string")
        &&
      (String4 != String5)
        &&
      (String4 > L"Test wchar string")
        &&
      (String4 >= String5)
        &&
      (String4 < L"Test wchar string")
        &&
      (String4 <= String5)
        &&
      (String4.Lower())
        &&
      (String4.Size( & StringSize ))
        &&
      (String4.Upper())
        &&
      (String4.Value( & Scope,64,& StringSize,Value2 ))
      )
    { printf( "We can compare wchar strings\n" ); }

  return 0;
  }

