#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_11
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "FixedString.hpp"
#include "Hash.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,64> KEY_TYPE;
typedef HASH<HEAP_TYPE,NO_LOCK,KEY_TYPE,int> HASH_TYPE;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  KEY_TYPE String = "One";
  HASH_TYPE Hash;

  if ( Hash.NewKey( String,1 ) )
    { printf( "New value stored in hash\n" ); }

  return 0;
  }
