#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_12
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "FixedString.hpp"
#include "Hash.hpp"
#include "RockallTypes.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,64> KEY_TYPE;
typedef HASH<HEAP_TYPE,NO_LOCK,KEY_TYPE,int> HASH_TYPE;

static BOOLEAN WalkFunction( KEY_TYPE & Key,int & Value,void *User )
  {
  int *UserValue = ((int*) User);

  printf( "Value: %d, User Value: %d\n",Value,(*UserValue) );

  return True;
  }

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  KEY_TYPE String = "One";
  HASH_TYPE Hash;
  FILE_SIZE Size;
  int Value;

  if
      (
      (Hash.NewKey( String,1,False ))
        &&
      (Hash.FindKey( String,& Value ))
        &&
      (Hash.Size( & Size ))
        &&
      (Hash.UpdateKey( String,2 ))
       &&
      (Hash.Walk( WalkFunction,((void*) & Value) ))
        &&
      (Hash.DeleteKey( String ))
        &&
      (Hash.DeleteAll())
      )
    { printf( "End of example\n" ); }

  return 0;
  }
