#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_16
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "Queue.hpp"
#include "RockallTypes.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef QUEUE<HEAP_TYPE,NO_LOCK,int> QUEUE_TYPE;

static BOOLEAN WalkFunction( int & Value,void *User )
  {
  int *UserValue = ((int*) User);

  printf( "Value: %d, User Value: %d\n",Value,(*UserValue) );

  return True;
  }

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  QUEUE_TYPE Queue( & Scope );
  FILE_SIZE Size;
  int Value;

  if
      (
      (Queue.PushValue( & Scope,1 ))
        &&
      (Queue.PeekValue( & Scope,& Value ))
        &&
      (Queue.Size( & Scope,& Size ))
        &&
      (Queue.Walk( & Scope,WalkFunction,((void*) & Value) ))
        &&
      (Queue.PopValue( & Scope,& Value ))
        &&
      (Queue.DeleteAll( & Scope ))
      )
    { printf( "End of example\n" ); }

  return 0;
  }
