#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_20
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "RockallTypes.hpp"
#include "Set.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef SET<HEAP_TYPE,NO_LOCK,int> SET_TYPE;

static BOOLEAN WalkFunction( int & Value,void *User )
  {
  int *UserValue = ((int*) User);

  printf( "Value: %d, User Value: %d\n",Value,(*UserValue) );

  return True;
  }

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  SET_TYPE Set1;
  SET_TYPE Set2;
  SET_TYPE Set3;
  FILE_SIZE Size;
  int Values[64];

  if
      (
      (Set1.NewValue( 1 ))
        &&
      (Set2.Copy( & Set1 ))
        &&
      (Set3.Difference( & Set1 ))
        &&
      (Set1.FindValue( 1 ))
        &&
      (Set2.Intersect( & Set1 ))
        &&
      (Set2.Join( & Set1 ))
        &&
      (Set1.Size( & Size ))
        &&
      (Set1.Value( 64,& Size,Values ))
        &&
      (Set1.Walk( WalkFunction,((void*) & Values[0]) ))
        &&
      (Set1.DeleteValue( 1 ))
        &&
      (Set1.DeleteAll())
      )
    { printf( "End of example\n" ); }

  return 0;
  }
