#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_21
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "RockallTypes.hpp"
#include "Set.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef SET<HEAP_TYPE,NO_LOCK,int> SET_TYPE;

static BOOLEAN WalkFunction( int & Value,void *User )
  {
  int *UserValue = ((int*) User);

  printf( "Value: %d, User Value: %d\n",Value,(*UserValue) );

  return True;
  }

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  SET_TYPE Set1( & Scope );
  SET_TYPE Set2( & Scope );
  SET_TYPE Set3( & Scope );
  FILE_SIZE Size;
  int Values[64];

  if
      (
      (Set1.NewValue( & Scope,1 ))
        &&
      (Set2.Copy( & Scope,& Set1 ))
        &&
      (Set3.Difference( & Scope,& Set1 ))
        &&
      (Set1.FindValue( & Scope,1 ))
        &&
      (Set2.Intersect( & Scope,& Set1 ))
        &&
      (Set2.Join( & Scope,& Set1 ))
        &&
      (Set1.Size( & Scope,& Size ))
        &&
      (Set1.Value( & Scope,64,& Size,Values ))
        &&
      (Set1.Walk( & Scope,WalkFunction,((void*) & Values[0]) ))
        &&
      (Set1.DeleteValue( & Scope,1 ))
        &&
      (Set1.DeleteAll( & Scope ))
      )
    { printf( "End of example\n" ); }

  return 0;
  }
