#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_22
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "FixedString.hpp"
#include "SingleThreadedHeap.hpp"
#include "Tree.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,64> KEY_TYPE;
typedef TREE<HEAP_TYPE,NO_LOCK,KEY_TYPE,int> TREE_TYPE;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  KEY_TYPE String = "One";
  TREE_TYPE Tree;

  if ( Tree.NewKey( String,1 ) )
    { printf( "New value stored in tree\n" ); }

  return 0;
  }
