#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_23
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "FixedString.hpp"
#include "RockallTypes.hpp"
#include "SingleThreadedHeap.hpp"
#include "Tree.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,64> KEY_TYPE;
typedef TREE<HEAP_TYPE,NO_LOCK,KEY_TYPE,int> TREE_TYPE;

static BOOLEAN WalkFunction( KEY_TYPE & Key,int & Value,void *User )
  {
  int *UserValue = ((int*) User);

  printf( "Value: %d, User Value: %d\n",Value,(*UserValue) );

  return True;
  }

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  KEY_TYPE String1 = "One";
  KEY_TYPE String2 = "A";
  KEY_TYPE String3 = "Z";
  KEY_TYPE String4;
  TREE_TYPE Tree;
  FILE_SIZE Size;
  int Value;

  if
      (
      (Tree.NewKey( String1,1,False ))
        &&
      (Tree.FindKey( String1,& Value ))
        &&
      (Tree.FindKeys( String2,String3,1,& Size,& String4,& Value ))
        &&
      (Tree.Size( & Size ))
        &&
      (Tree.UpdateKey( String1,2 ))
        &&
      (Tree.Walk( WalkFunction,((void*) & Value) ))
        &&
      (Tree.DeleteKey( String1 ))
        &&
      (Tree.DeleteAll())
      )
    { printf( "End of example\n" ); }

  return 0;
  }
