#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_26
#endif

#include <stdio.h>

#include "AutomaticLockScope.hpp"
#include "FileLock.hpp"

int main( void )
  {
  FILE_LOCK Lock;

  // No lock owned.
  Lock.ClaimExclusiveLock();
  // Exclusive lock owned.
  Lock.ReleaseExclusiveLock();

  // No lock owned.
  {
  AUTOMATIC_EXCLUSIVE_LOCK_SCOPE<FILE_LOCK> ExclusiveLock( & Lock );
  // Exclusive lock owned.
  }

  // No lock owned.
  {
  AUTOMATIC_EXCLUSIVE_LOCK_SCOPE<FILE_LOCK> ExclusiveLock( & Lock );
  // Exclusive lock owned.
  ExclusiveLock.Release();
  // No lock owned.
  ExclusiveLock.Reclaim();
  // Exclusive lock owned.
  }

  // No lock owned.
  Lock.ClaimSharedLock();
  // Shared lock owned.
  Lock.ReleaseSharedLock();

  // No lock owned.
  {
  AUTOMATIC_SHAREABLE_LOCK_SCOPE<FILE_LOCK> SharedLock( & Lock );
  // Shared lock owned.
  }

  // No lock owned.
  return 0;
  }
