#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_29
#endif

#include "AutomaticHeapScope.hpp"
#include "AutomaticTransactionScope.hpp"
#include "DatabaseHeap.hpp"
#include "RockallDelete.hpp"
#include "RockallNew.hpp"
#include "RockallTypes.hpp"

typedef DATABASE_HEAP HEAP_TYPE;

int main( int Count,char *Argument[] )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  FILE_ADDRESS Address;
  int Result = 0;
  int *Data;

  if ( (Count == 2) && (Scope.CreateFile( Argument[1] )) )
    {
      // No transaction.
      {
      AUTOMATIC_TRANSACTION_SCOPE<HEAP_TYPE> Transaction( & Scope );

      if ( Transaction.BeginTransaction() )
        {
        // Active transaction.
        if ( ! ROCKALL_NEW<int>::New( & Scope,& Address,& Data ) )
          { Result = 1; }
        }
      }

      // No transaction.
      {
      AUTOMATIC_TRANSACTION_SCOPE<HEAP_TYPE> Transaction( & Heap );

      if ( Transaction.BeginTransaction() )
        {
        // Active transaction.
        if ( ! ROCKALL_DELETE<int>::Delete( & Heap,Address ) )
          { Result = 1; }

        Transaction.EndTransaction();
        // No transaction.
        }
      }

    Scope.CloseFile();
    }

  return Result;
  }

