#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_31
#endif

#include <stdio.h>

#include "LinkedList.hpp"
#include "RockallTypes.hpp"

//
//  A linked list element.
//
class ELEMENT : public LINKED_LIST<ELEMENT>
  {
  public:
    int Value;

    ELEMENT( int NewValue = 0 )
      { Value = NewValue; }

    ~ELEMENT( void )
      { Value = 0; }
  };

//
//  A linked list header.
//
typedef LINKED_LIST<ELEMENT> HEADER;

int main( void )
  {
  ELEMENT Element[4] = { 0,1,2,3 };
  ELEMENT *Current;
  HEADER Header;

  //
  //  Insert 'Element[0]' at the head of the list
  //  and 'Element[3]' at the end of the list.
  //
  Element[0].InsertFirst( & Header );
  Element[3].InsertLast( & Header );

  //
  //  Insert 'Element[1]' after 'Element[0]' then
  //  insert 'Element[2]' before 'Element[3]' in
  //  the list.
  //
  Element[1].InsertAfter( & Header,& Element[0] );
  Element[2].InsertBefore( & Header,& Element[3] );

  //
  //  We iterate the list in 'Forwards()' order.
  //
  for
      (
      Current = Header.First();
      ! Current -> End();
      Current = Current -> Forwards()
      )
    {
    //
    //  We visit each list 'ELEMENT' in 'Forwards()'
    //  order.
    //

    printf( "%d\n",Current -> Value );
    }

  //
  //  We iterate the list in 'Backwards()' order.
  //
  for
      (
      Current = Header.Last();
      ! Current -> End();
      Current = Current -> Backwards()
      )
    {
    //
    //  We visit each list 'ELEMENT' in 'Backwards()'
    //  order.
    //

    printf( "%d\n",Current -> Value );
    }

  //
  //  We unlink all the elements from the end of
  //  the list until it is empty.
  //
  for
      (
      Current = Header.Last();
      ! Current -> End();
      Current = Header.Last()
      )
    { Current -> Unlink( & Header ); }

  return 0;
  }
