#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_32
#endif

#include "AutomaticHeapScope.hpp"
#include "AutomaticTransactionScope.hpp"
#include "DatabaseHeap.hpp"
#include "PlacementNew.hpp"
#include "RockallTypes.hpp"

typedef DATABASE_HEAP HEAP_TYPE;
typedef struct { int Value; } DATA;

int main( int Count,char *Argument[] )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  FILE_ADDRESS Address;
  DATA *Data;

  if ( (Count == 2) && (Scope.CreateFile( Argument[1] )) )
    {
      // No transaction.
      {
      AUTOMATIC_TRANSACTION_SCOPE<HEAP_TYPE> Transaction( & Scope );

      if ( Transaction.BeginTransaction() )
        {
        // Active transaction.
        if ( Scope.New( & Address,((void**) & Data),sizeof(DATA) ) )
          {
          PLACEMENT_NEW( Data,DATA );
          //  Active allocation ready for use.
          PLACEMENT_DELETE( Data,DATA  );

          Scope.Delete( Address );
          }
        }
      }

    // No transaction.
    Scope.CloseFile();
    }

  return 0;
  }

